#include <smconfig.h>
#include <stdio.h>
#include <setjmp.h>
#include <ctype.h>
#include <math.h>

#define __LIST__

 /*
  * HZ should be defined in <sys/param.h>
  */

#ifndef  __PARAM_HEADER__
#include <sys/param.h>
#endif

#ifndef HZ
#define HZ 60
#endif

 /*
  * Definition of time_t and of the data types in the struct stat
  */

#ifndef  _TYPES_
#include <sys/types.h>
#endif

 /*
  * Definition of struct tms
  */

#include <sys/times.h>

 /*
  * Definition of struct stat
  */

#ifndef __STAT_HEADER__
#include <sys/stat.h>
#endif

#ifndef _NFILE
#define _NFILE NOFILE
#endif



#define 	BASIS 	(1<<30)
#define 	_0 	(1<<30)
#define 	ERROR 	(-(1<<30))
#define 	atom 	int
#define 	single 	int
#define 	list 	int
#define 	obj 	int



 /*
  * WARNING! Since version 3.10.2, on all systems except for HP-UX, the last 
  * two bits are used for storage management. This requires that the addresses
  * of memory allocated by a SIMATH process must be divisible by 4.
  */
			
#ifdef ___HP
#define 	ltop(L) 	((PCELL)(L))
#define 	ptol(p) 	((int) (p))
#else
#define 	ltop(L) 	((PCELL) ((L) << 2))
#define 	ptol(p) 	((((int) (p)) >> 2) | BASIS)
#endif



#define           fgetc  xfgetc
#define           fgets  xfgets
#define         fprintf  xfprintf
#define           fputc  xfputc
#define     fputo(a,pf)  (isatom(a)?fputa(a,pf):fputl(a,pf))
#define           fputs  xfputs
#define          geta()  fgeta(stdin)
#undef getc
#define            getc  xfgetc
#undef getchar
#define       getchar()  xfgetc(stdin)
#define         getcb()  fgetcb(stdin)
#define         getcs()  fgetcs(stdin)
#define            gets  xgets
#define          getl()  fgetl(stdin)
#define          geto()  fgeto(stdin)
#define        lines(k)  flines(k,stdout)
#define          printf  xprintf
#define         puta(a)  fputa(a,stdout)
#define      putbits(a)  fputbits(a,stdout)
#undef  putc
#define      putc(c,pf)  xfputc(c,pf)
#undef  putchar
#define      putchar(c)  xfputc(c,stdout)
#define         putl(L)  fputl(L,stdout)
#define   putlstruct(L)  fputlstruct(L,stdout)
#define         puto(a)  (isatom(a)?fputa(a,stdout):fputl(a,stdout))
#define         puts(s)  xfputs(s,stdout)
#define    sputa(a,str)  ( sprintf(str,"%d",a), str )
#define          tab(n)  ftab(n,stdout)

# define               isatom(a)  ( (a) > -BASIS && (a) < BASIS )
# define             issingle(a)  isatom(a)
# define                isobj(a)  ( isatom(a) || islist(a) )
# define           lcomp2(a,b,L)  lcomp(a,lcomp(b,L))                     
                              /*a*/
# define         lcomp3(a,b,c,L)  lcomp(a,lcomp(b,lcomp(c,L)))            
                              /*a,b*/
# define       lcomp4(a,b,c,d,L)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,L))))   
                              /*a,b,c*/
# define     lcomp5(a,b,c,d,e,L)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,lcomp(e,L)))))
			     /*a-d*/
# define   lcomp6(a,b,c,d,e,f,L)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,lcomp(e,lcomp(f,L))))))
			     /*a-e*/
# define  lfirst(L)  ((ltop(L))->inh)
# define  lred(L)  ((ltop(L))->adr)

# define  lsecond(L)  (lfirst( lred(L) ) )
# define  lthird(L)   (lfirst( lred( lred(L) ) ) )
# define  lfourth(L)  (lfirst( lred( lred ( lred(L) ) ) ) )
# define  lfifth(L)   (lfirst( lred( lred( lred ( lred(L)  ) ) ) ) )

# define                list1(a)  lcomp(a,_0)
# define              list2(a,b)  lcomp(a,lcomp(b,_0))                    
                             /*a*/
# define            list3(a,b,c)  lcomp(a,lcomp(b,lcomp(c,_0)))           
                             /*a,b*/
# define          list4(a,b,c,d)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,_0))))  
                             /*a,b,c*/
# define        list5(a,b,c,d,e)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,lcomp(e,_0)))))
			     /*a-d*/
# define      list6(a,b,c,d,e,f)  lcomp(a,lcomp(b,lcomp(c,lcomp(d,lcomp(e,lcomp(f,_0))))))
			     /*a-e*/

# define  lred2(L)  (lred( lred( L ) ))
# define  lred3(L)  (lred( lred( lred( L ) ) ))
# define  lred4(L)  (lred( lred( lred( lred ( L ) ) ) ) )
# define  lred5(L)  (lred( lred( lred( lred (lred (L) ) ) ) ) )           


typedef struct {
	int adr;
	int inh;
} CELL, *PCELL;  


# define  lsfirst(L,a)  ( ((ltop(L))->inh)=(a) )
                             /*L oder a keine Fkt*/
# define  lsred(L,L1)  ( ((ltop(L))->adr)=(L1) )
                             /*L oder L1 keine Fkt*/


# define            lsuffix(L,a)  lconc(L,lcomp(a,_0))
			     /*L*/
# define            usunion(L,M)  lconc(usdiff(L,M),M)
			     /*M*/



# define 	lsize(l)  lsizerec (l,1)



extern PCELL   SPACE;
extern PCELL   *BL_START;
extern int     SP_MAX, ST_SIZE /*, STOCK_SZ */;
extern int     BL_SIZE, BL_NR, BL_NR_MAX, BL_NR_MSG;
extern int     GC_CC, GC_COUNT, GC_MESS, GC_QUOTE, GC_TEST, GC_TIME;
extern int     ST_INDEX, **STACK /*, *STOCK */;
extern list    AVAIL;
extern single  LN_SIZE, MARGIN;
extern obj     DUM, NUM;
extern jmp_buf FL_JMP;




/* extern int  STOCK_IND; */
/* extern int  TRACE_ON, TRACE_CC; */
